class DioderDriver {
  char r,g,b;
  char[] mapR, mapG, mapB;
  
  Serial serial;
  
  boolean dummyMode;
  
  DioderDriver(PApplet parent) {
    dummyMode = (parent == null);
    
    r = 0;
    g = 0;
    b = 0;
    
    mapR = linear();
    mapG = linear();
    mapB = linear();
    
    if (!dummyMode) {
      String portName = Serial.list()[0];
      serial = new Serial(parent, portName, 9600);
    }
  }
  
  char[] linear() {
    char[] m = new char[256];
    for (char i=0; i<256; i++) {
      m[i] = i;
    }
    return m;
  }
  
  char[] gammaCorrection(float gamma) {
    char[] m = new char[256];
    for (char i=0; i<256; i++) {
      float x = i / 256.0f;
      float y = pow(x, gamma);      
      m[i] = (char)(y * 256.0f);
    }
    return m;
  }
  
  void update() {
    if (!dummyMode) {
      serial.write(mapG[g]);
      serial.write(mapB[b]);
      serial.write(mapR[r]);
    }
  }
};
