class Plot extends Control {
  char[] data;
  String caption;
  color col;
  
  Plot(int x, int y, int w, int h, String caption) {
    super(x,y,w,h);
    this.caption = caption;
    data = null;
    col = color(255,255,255);
  }
  
  void draw() {
    fill(0);
    rect(x,y,w,h);
    pushStyle();
    strokeWeight(2);
    stroke(col);
    int prevX = x;
    int prevY = y-data[0]+h;
    
    if (data != null) {
      for (int i=1; i<data.length; i++) {
        int currX = x+i;
        int currY = y-data[i]+h;
        line(prevX, prevY, currX, currY);
        prevX = currX;
        prevY = currY;
      }
    }
    popStyle();
  }  
}
